/**
 * ab_two_gis_maps package for Concrete5
 * Copyright Copyright 2017-2018, Alex Borisov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author Alex Borisov <linuxoidoz@gmail.com>
 * @package Concrete\Package\ab_two_gis_maps
 */

$(document).ready(function(e) {
    if(CCM_EDIT_MODE){
        return;
    }
    
    DG.then(function() {
        $.each($('.ab-two-gis-map[data-js_data]'), function(index, element){
            var js_data = $.parseJSON($(element).attr('data-js_data'));
            init(element, js_data);
        });
    });
});

function init(element, js_data) {
    var balloon = '<div class="my-balloon">';
        if (js_data.show_picture) {
            balloon += '<div class="left">';
                balloon += '<img src="' + js_data.picture + '" />';
            balloon += '</div>';
        }
        balloon += '<div class="right">'; 
            balloon += '<h3>' + js_data.name + '</h3>';
            balloon += js_data.show_address ? ('<strong>' + js_data.t_address + '</strong> ' + js_data.address + '<br />') : '';
            balloon += js_data.show_tel ? ('<strong>' + js_data.t_tel + '</strong> ' + js_data.tel + '<br />') : '';
            balloon += js_data.show_email ? ('<strong>' + js_data.t_email + '</strong> <a href="mailto:' + js_data.email + '">' + js_data.email + '</a>') : '';
        balloon += '</div>';
    balloon += '</div>';
        
    var myMap, myPopUp, myPlacemark;

    myMap = DG.map(element, {
        'center': [js_data.latitude, js_data.longitude],
        'zoom': js_data.zoom ? js_data.zoom : 12,
        'scrollWheelZoom' : js_data.lock_wheel,
    });
    myMap.setLang(js_data.t_lang);

    myPopUp = DG.popup();
    myPopUp.setLatLng([js_data.latitude, js_data.longitude]);
    myPopUp.setContent(balloon);
    
    myPlacemark = DG.marker([js_data.latitude, js_data.longitude]).addTo(myMap);
    myPlacemark.bindPopup(myPopUp);
    myPlacemark.bindLabel(js_data.name, {
        static: true,
    });
};
